-------------------------------------------------------------------------------
-- Set up some local variables
-------------------------------------------------------------------------------
CCPatience = {}

--uncomment the back you wish to use
local backofcard = "Interface\\AddOns\\CCLibrary\\Images\\allianceback"
--local backofcard = "Interface\\AddOns\\CCLibrary\\Images\\hordeback"
local cardBack = 0
local cardOffset
local OneCard = false
local DealNum
local CCPatienceCards = {}
local CCPatienceCardFrames = {}
local DrawDeck = {}
local relTo, xOff, yOff, lev, topCard, oldCheck
local anchoredCount = 0
local drawCount = 0
--number of cards in deck at the start
local deckNum = 24
local ResetFlag = 0
local showFlag = 0
local msg, title, height, width
local bg = {}




-------------------------------------------------------------------------------
--Functions for each frame, etc
-------------------------------------------------------------------------------


function CCPatience:OnLoad(mainFrame)
    mainFrame:RegisterForDrag("RightButton")
    mainFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
    mainFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
    mainFrame:CreateTitleRegion()
    --create all the frames
    for i = 1, 52 do 
        name = string.format("CardFrame%d", i)
        frame = CreateFrame("Button", name, PatienceFrame, "CardTemplate")
        CCPatienceCardFrames[name] = frame
    end
    CCPatienceCards = CCLibrary:CreateDeck(1, 0)
end


--resets the game frames so they are ready to be used in a fresh game
function CCPatience:init()
    --will make OneCard either 2 if was 0 or 0 if was 1
    --DealNum = math.abs((OneCard - 1) * 2)
    if OneCard == true then
        DealNum = 0
    else
        DealNum = 2
    end
    CCLibrary:SetCardToFrame(PatienceFrameTopSlot1, 0, nil, nil, PatienceFrameTopSlot1)
    CCLibrary:SetCardToFrame(PatienceFrameTopSlot2, 0, nil, nil, PatienceFrameTopSlot2)
    CCLibrary:SetCardToFrame(PatienceFrameTopSlot3, 0, nil, nil, PatienceFrameTopSlot3)
    CCLibrary:SetCardToFrame(PatienceFrameTopSlot4, 0, nil, nil, PatienceFrameTopSlot4)
    CCLibrary:SetCardToFrame(PatienceFrameBottomSlot1, 0, nil, nil, PatienceFrameBottomSlot1)
    CCLibrary:SetCardToFrame(PatienceFrameBottomSlot2, 0, nil, nil, PatienceFrameBottomSlot2)
    CCLibrary:SetCardToFrame(PatienceFrameBottomSlot3, 0, nil, nil, PatienceFrameBottomSlot3)
    CCLibrary:SetCardToFrame(PatienceFrameBottomSlot4, 0, nil, nil, PatienceFrameBottomSlot4)
    CCLibrary:SetCardToFrame(PatienceFrameBottomSlot5, 0, nil, nil, PatienceFrameBottomSlot5)
    CCLibrary:SetCardToFrame(PatienceFrameBottomSlot6, 0, nil, nil, PatienceFrameBottomSlot6)
    PatienceFrameBottomSlot0:SetAttribute("rowCount", 0)
    PatienceFrameBottomSlot1:SetAttribute("rowCount", 1)
    PatienceFrameBottomSlot2:SetAttribute("rowCount", 2)
    PatienceFrameBottomSlot3:SetAttribute("rowCount", 3)
    PatienceFrameBottomSlot4:SetAttribute("rowCount", 4)
    PatienceFrameBottomSlot5:SetAttribute("rowCount", 5)
    PatienceFrameBottomSlot6:SetAttribute("rowCount", 6)
    deckNum = 24
    drawCount = 0
    ResetFlag = 0
    anchoredCount = 0
    
    bg = PatienceFrameDeckSlot:GetBackdrop()
    bg.bgFile = backofcard
    PatienceFrameDeckSlot:SetBackdrop(bg)
    PatienceFrameDeckSlot:SetBackdropBorderColor(0, 0, 0)

end

---------------------------------------------------------------------
--Function to Deal out all cards at the start of a new game
---------------------------------------------------------------------
function CCPatience:Deal()
    local r = 0
    local c = 0
    local YOffset, relativeTo 
    local cardNum = 1
    local number, suit, face, colour
    local text, name
    
    CCPatience:init()
   
    for r = 0, 6 do
        for c = r, 6 do
            --put the cards in place
            name = string.format("CardFrame%d", cardNum)

            frame = CCPatienceCardFrames[name]
            
            --places frames on top of one another, the + 1 is so 
            --that it is higher than the MainFrame.
            frame:SetFrameLevel(r + 1 + PatienceFrame:GetFrameLevel())
            
            --sets the YOffset, for each row cards move an extra 5 pixels downwards.
            YOffset = -5 * r
            
            --creates the name of the anchor point. (relativeTo)
            relativeTo = string.format("PatienceFrameBottomSlot%d", c)
            
            --anchors the card to the relevant frame
            frame:SetPoint("TOPLEFT", relativeTo, "TOPLEFT", 0, YOffset)
            
            --get the details on that card
            number, suit, face, colour = CCLibrary:IdentifyCard(CCPatienceCards[cardNum])
            
            --set these details to the card as attributes.
            frame:SetAttribute("number", number)
            frame:SetAttribute("suit", suit) 
            frame:SetAttribute("colour", colour)
            frame:SetAttribute("column", c)
            frame:SetAttribute("row", r + 1)
            frame:SetAttribute("deck", false)
            frame:SetAttribute("anchored", nil)

            bg = frame:GetBackdrop()
            --checks if the card is faceup or not!
            if r ~= c then
                frame:SetAttribute("faceup", false)
                --TODO change this to allow images
                --changes the Backdrop to show it is the back of the card
                bg.bgFile = backofcard
                frame:SetBackdrop(bg)
                --frame:SetBackdropColor(0, 0, 1, 1)
                frame:SetMovable(false)
            else
                frame:SetAttribute("faceup", true)
                
                bg.bgFile = string.format("Interface\\AddOns\\CCLibrary\\Images\\card%d%s", number, suit)
                frame:SetBackdrop(bg)
                relativeTo = CCPatience:GetColumn(c, 0)
                --calls the function that allows the card to give its values to the frame
                CCLibrary:SetCardToFrame(frame, number, colour, suit, relativeTo)
            end
            
            frame:SetBackdropBorderColor(0, 0, 0)

            cardNum = cardNum + 1

        end
    end    
    --now to create all the other cards
    for cardNum = 29, 52 do
        name = string.format("CardFrame%d", cardNum)
        --frame = CreateFrame("Button", name, PatienceFrame, "CardTemplate")
        frame = CCPatienceCardFrames[name]
        
        frame:SetFrameLevel(PatienceFrameDrawSlot:GetFrameLevel() + (cardNum - 28))
        
        frame:SetPoint("TOPLEFT", PatienceFrameDrawSlot, "TOPLEFT", 0, 0)
        
        --get the details on that card
        number, suit, face, colour = CCLibrary:IdentifyCard(CCPatienceCards[cardNum])
        
        frame:SetAttribute("number", number)
        frame:SetAttribute("suit", suit) 
        frame:SetAttribute("colour", colour)
        frame:SetAttribute("column", 0)
        frame:SetAttribute("row", 0)
        frame:SetAttribute("deck", true)
        frame:SetAttribute("faceup", true)
        frame:SetAttribute("anchored", nil)
        
        bg = frame:GetBackdrop()
        bg.bgFile = string.format("Interface\\AddOns\\CCLibrary\\Images\\card%d%s", number, suit)
        frame:SetBackdrop(bg)
        frame:SetBackdropBorderColor(0, 0, 0)
        frame:Hide()
        
        DrawDeck[cardNum - 28] = frame
        CCPatienceCardFrames[name] = frame
    end    
end


---------------------------------------------------------------------
--Function to collect necessary data before a card is moved
---------------------------------------------------------------------
function CCPatience:OnDragStart(cardFrame)
    local anchored
    anchoredCount = 0
    
    _, relTo, _, xOff, yOff = cardFrame:GetPoint()
    lev = cardFrame:GetFrameLevel()
    if cardFrame:GetTop() == PatienceFrameTopSlot1:GetTop() then
        oldCheck = 1
    else
        oldCheck = 2
    end
    
    topCard = cardFrame
    
    --Makes all cards anchored to this card rise as well as the one being dragged
    anchored = cardFrame:GetAttribute("anchored")
    while anchored ~= nil do
        anchored:SetFrameLevel(anchored:GetFrameLevel() + 30)
        topCard = anchored
        anchored = anchored:GetAttribute("anchored")
        anchoredCount = anchoredCount + 1
    end
end

---------------------------------------------------------------------
--Function to finish moving a card, includes checks and pos snaps
---------------------------------------------------------------------
function CCPatience:MoveCards(cardFrame)
--Called when cards are placed
    local cardLoc, oldCardLoc
    local frameLoc = {}
    local diff = {}
    local closest
    local slot, oldSlot
    local anchorCard = {}
    local taken
    local relativeTo, yOffset
    local check
    
    --Get an x value of a card
    cardLoc = cardFrame:GetLeft()
    --print(cardFrame:GetName(), ": ", cardFrame:GetLeft())
    
    --loops through the slot frames and gets all the x values of the frame.
    --TODO make better, take the first one and add an integer to get the rest!
    for i = 0, 6 do
        slot = CCPatience:GetColumn(i, 0)
        frameLoc[i] = slot:GetLeft()
        
        --works out the difference between the card and the frame.
        --is made into an absolute value so they can be compared.
        diff[i] = math.abs(cardLoc - frameLoc[i])
    end
    
    --math.min takes the smallest value from the list.
    closest = math.min(diff[0], diff[1], diff[2], diff[3], diff[4], diff[5], diff[6]) 
    
    --dont need cardLoc anymore so will recycle the variable as a counter
    cardLoc = 0
    --determines which frame was closest (not really interested in the value)
    while diff[cardLoc] ~= closest do
        cardLoc = cardLoc + 1
    end
    --cardLoc will now be equal to the column the card needs to go to


    oldCardLoc = cardFrame:GetAttribute("column")
    --old anchor information
    check, slot = CCPatience:CheckMove(cardFrame, cardLoc)
        --if move is allowed!
    if check ~= 0 then
        --check it can go to that column if yes
             

        
        --changes the column variable to the current column
        cardFrame:SetAttribute("column", cardLoc)  
        anchorCard = slot:GetAttribute("card")
        taken = slot:GetAttribute("colour")
        
        if taken == nil or check == 1 then
            CCLibrary:anchorTo(cardFrame, anchorCard, 0, 0)
        else
            CCLibrary:anchorTo(cardFrame, anchorCard, 0, -15)
        end

    if taken ~= nil then
        CCPatience:returnToLevel(cardFrame, anchorCard:GetFrameLevel() + 1, cardLoc)
    else
        CCPatience:returnToLevel(cardFrame, slot:GetFrameLevel() + 1, cardLoc)
        --cardFrame:SetFrameLevel(slot:GetFrameLevel() + 1)
    end
    --erase this cards details from its old frame
        oldSlot = CCPatience:GetColumn(oldCardLoc, oldCheck)
        --remove the details from that frame.
        
        if cardFrame:GetAttribute("deck") == false then 
            if oldCheck == 1 and cardFrame:GetAttribute("number") ~= 1 then
                CCLibrary:SetCardToFrame(relTo, 
                                    cardFrame:GetAttribute("number") - 1, 
                                    cardFrame:GetAttribute("colour"),
                                    cardFrame:GetAttribute("suit"),
                                    oldSlot)
                
            elseif relTo ~= oldSlot and relTo ~= nil then
                --card came from on top of another card
                CCLibrary:SetCardToFrame(relTo, 
                                          relTo:GetAttribute("number"),
                                          relTo:GetAttribute("colour"),
                                          relTo:GetAttribute("suit"),
                                          oldSlot)
            else
                CCLibrary:SetCardToFrame(oldSlot, 0, nil, nil, oldSlot)
            end
            if relTo ~= nil then
                relTo:SetAttribute("anchored", nil)
            end
        end
        

        
        --set the new frame to be of the new cards attributes
        CCLibrary:SetCardToFrame(topCard, 
                                  topCard:GetAttribute("number"), 
                                  topCard:GetAttribute("colour"),
                                  topCard:GetAttribute("suit"),
                                  slot)
                                  
        anchorCard:SetAttribute("anchored", cardFrame)

        --remove the card from the deck
        if cardFrame:GetAttribute("deck") == true then
            
                table.remove(DrawDeck, drawCount)
                deckNum = deckNum - 1
                drawCount = drawCount - 1
                cardFrame:SetAttribute("deck", false)
           
        end

        --check to see if game is won!
        if PatienceFrameTopSlot1:GetAttribute("number") == 13 then
            if PatienceFrameTopSlot2:GetAttribute("number") == 13 then
                if PatienceFrameTopSlot3:GetAttribute("number") == 13 then
                    if PatienceFrameTopSlot4:GetAttribute("number") == 13 then
                        --PLAYER HAS WON!!
                        height = 150
                        width = 300
                        title = "\nCONGRATULATIONS\n\nYou Have Won!"
                        msg = ""
                        CCPatience:DisplayFrame(height, width, msg, title, 1)
                    end
                end
            end
        end
        
    else
        --move back to where it was
        CCLibrary:anchorTo(cardFrame, relTo, xOff, yOff)
        --cardFrame:SetFrameLevel(lev)
        CCPatience:returnToLevel(cardFrame, lev, cardLoc)
        
    end
    
    cardFrame:SetHeight(100)
    cardFrame:SetWidth(71)
end

---------------------------------------------------------------------
--Function to return all cards to the correct level
---------------------------------------------------------------------
function CCPatience:returnToLevel(cardFrame, level, cardLoc)
    local anchored
    
    cardFrame:SetFrameLevel(level)
    
    anchored = cardFrame:GetAttribute("anchored")
    if anchored ~= nil then
        for i = 1, anchoredCount do
            anchored:SetFrameLevel(cardFrame:GetFrameLevel() + i)
            anchored:SetAttribute("column", cardLoc)
            anchored = anchored:GetAttribute("anchored")
        end
    end
end



---------------------------------------------------------------------
--Function to check the Move made is legal
---------------------------------------------------------------------
function CCPatience:CheckMove(cardFrame, column)
--check the card can go onto the position
--returns 0 if move not allowed, 1 if yes @top and 2 if yes @bottom
    local Line = PatienceFrame:GetTop() - 108
    local slotFrame
    
    if cardFrame:GetAttribute("deck") == true and DrawDeck[drawCount] ~= cardFrame then
        return 0, slotFrame
    end
    
    if cardFrame:GetTop() > Line then
        --top frame
        slotFrame = CCPatience:GetColumn(column, 1)
        if slotFrame == nil then return 0, slotFrame end
        --if ace
        if cardFrame:GetAttribute("number") == 1 and slotFrame:GetAttribute("colour") == nil then
            return 1, slotFrame
        elseif slotFrame:GetAttribute("colour") == nil then
            return 0, slotFrame
        elseif cardFrame:GetAttribute("number") == slotFrame:GetAttribute("number") + 1 and 
                cardFrame:GetAttribute("suit") == slotFrame:GetAttribute("suit") then
            return 1, slotFrame
        else
            return 0, slotFrame
        end
    else
        --bottom Frame
        slotFrame = CCPatience:GetColumn(column, 0)
        
        --if king

        if cardFrame:GetAttribute("number") == 13 and slotFrame:GetAttribute("colour") == nil then
            return 2, slotFrame
        elseif slotFrame:GetAttribute("colour") == nil then
            return 0, slotFrame
        elseif cardFrame:GetAttribute("number") == slotFrame:GetAttribute("number") - 1 and
                cardFrame:GetAttribute("colour") ~= slotFrame:GetAttribute("colour") then
            return 2, slotFrame
        else 
            return 0, slotFrame
        end
    end
    
end

---------------------------------------------------------------------
--function to determine the slot object of column c
---------------------------------------------------------------------
function CCPatience:GetColumn(c, level)
--since it cant be strings and must be table, this function was the only I could
--think of doing it.  But it works so I am happy.
    local relativeTo
    --this is the closest I could find to a switch statement
    if level == 1 then
        if c == 0 then relativeTo = nil
        elseif c == 1 then relativeTo = nil
        elseif c == 2 then relativeTo = nil
        elseif c == 3 then relativeTo = PatienceFrameTopSlot1
        elseif c == 4 then relativeTo = PatienceFrameTopSlot2
        elseif c == 5 then relativeTo = PatienceFrameTopSlot3
        elseif c == 6 then relativeTo = PatienceFrameTopSlot4
        else ChatFrame1:AddMessage("ERROR")
        end
    else    
        if c == 0 then relativeTo = PatienceFrameBottomSlot0
        elseif c == 1 then relativeTo = PatienceFrameBottomSlot1
        elseif c == 2 then relativeTo = PatienceFrameBottomSlot2
        elseif c == 3 then relativeTo = PatienceFrameBottomSlot3
        elseif c == 4 then relativeTo = PatienceFrameBottomSlot4
        elseif c == 5 then relativeTo = PatienceFrameBottomSlot5
        elseif c == 6 then relativeTo = PatienceFrameBottomSlot6
        else ChatFrame1:AddMessage("ERROR")
        end
    end
    return relativeTo
end

---------------------------------------------------------------------
--function to Turn over face down cards
---------------------------------------------------------------------
function CCPatience:TurnCards(cardFrame)
    local column = cardFrame:GetAttribute("column")
    local row = cardFrame:GetAttribute("row")
    local slotFrame = CCPatience:GetColumn(column, 0)
    
    if cardFrame:GetAttribute("faceup") == false then
        if slotFrame:GetAttribute("rowCount") == row and 
                slotFrame:GetAttribute("colour") == nil then
            --change faceup to true
            cardFrame:SetAttribute("faceup", true)
            --make card movable
            cardFrame:SetMovable(true)
            --redraw card to show face
            local bg = cardFrame:GetBackdrop()
            bg.bgFile = string.format("Interface\\AddOns\\CCLibrary\\Images\\card%d%s", cardFrame:GetAttribute("number"), cardFrame:GetAttribute("suit"))
            cardFrame:SetBackdrop(bg)
            cardFrame:SetBackdropBorderColor(0, 0, 0)
            --reduce slotFrame rowCount by 1
            slotFrame:SetAttribute("rowCount", row - 1)
            --set slotFrame attributes to match card
            CCLibrary:SetCardToFrame(cardFrame, 
                                     cardFrame:GetAttribute("number"), 
                                     cardFrame:GetAttribute("colour"),
                                     cardFrame:GetAttribute("suit"),
                                     slotFrame)
        end
    
    end
end


---------------------------------------------------------------------
--function to draw cards when click on the deck
---------------------------------------------------------------------
function CCPatience:DrawCards()
    
--TODO

    local draw
    local xOffset
    local flag
    

    if ResetFlag == 0 then
        for i = 0, DealNum do
        --needs to show next card
        
            --check not at end of deck

            if drawCount == deckNum then
                --reset
                
                --for loop used for 3 card version
                if i == 0 then
                    --this means first time round, so player has just clicked
                    for j = 1, deckNum do
                        DrawDeck[j]:Hide()
                       -- print("hide 1")
                    end
                    drawCount = 0
                    --if statement to stop deck turning back once clicked if there are no cards in deck
                    if deckNum ~= 0 then
                        bg = PatienceFrameDeckSlot:GetBackdrop()
                        bg.bgFile = backofcard
                        PatienceFrameDeckSlot:SetBackdrop(bg)
                        --PatienceFrameDeckSlot:SetBackdropColor(1, 1, 1, 1)
                        PatienceFrameDeckSlot:SetBackdropBorderColor(0, 0, 0)
                    end
                else
                    ResetFlag = 1
                end
                break
            else
                drawCount = drawCount + 1
               -- print("show 1")
                DrawDeck[drawCount]:SetPoint("TOPLEFT", PatienceFrameDrawSlot, "TOPLEFT", i * 15, 0)
                DrawDeck[drawCount]:Show()
                if i == 0 then
                    for j = 1, 3 do
                        if DrawDeck[drawCount - j] ~= nil then
                            DrawDeck[drawCount - j]:SetPoint("TOPLEFT", PatienceFrameDrawSlot, "TOPLEFT", 0, 0)
                        end
                    end
                end
                if drawCount == deckNum then 
                    bg = PatienceFrameDeckSlot:GetBackdrop()
                    bg.bgFile = "Interface\\AddOns\\CCLibrary\\Images\\whitebg"
                    PatienceFrameDeckSlot:SetBackdrop(bg)
                    PatienceFrameDeckSlot:SetBackdropColor(0, 0.2, 0, 1)
                    PatienceFrameDeckSlot:SetBackdropBorderColor(0, 0, 0)
                end
            end
        end
    else
    --used for 3 card version
        for j = 1, deckNum do
            DrawDeck[j]:Hide()            
            --print("hide 2")
        end
        drawCount = 0
        if deckNum ~= 0 then
            bg = PatienceFrameDeckSlot:GetBackdrop()
            bg.bgFile = backofcard
            PatienceFrameDeckSlot:SetBackdrop(bg)
            --PatienceFrameDeckSlot:SetBackdropColor(1, 1, 1, 1)
            PatienceFrameDeckSlot:SetBackdropBorderColor(0, 0, 0)
        end
        ResetFlag = 0
    end
end

function CCPatience:OnHide()
    PatienceFrame:Hide()
    showFlag = 0
    print("Type /ccshow to open again")
end

function CCPatience:NewGame()
    CCLibrary:Shuffle(52, CCPatienceCards)
    CCPatience:Deal()
    CClibraryAboutFrame:Hide()
end



-------------------------------------------------------------------------------
--Dropdown menus section DO NOT TOUCH, GRAEME!!!
-------------------------------------------------------------------------------

function CCPatience_InitializeFileDropDown(level)
    --create a table to use for local information
--create a table to use for local information
        local file = {}
    
        --create a title button
        file.text = "Options"
        file.isTitle = 1
        UIDropDownMenu_AddButton(file)
    
        --NEW GAME BUTTON 
        file = {}
        file.text = "New Game"
        function file.func()
            CCPatience:NewGame()
        end
        UIDropDownMenu_AddButton(file)
    
   
        --DRAW ONE CARD CHECK BUTTON
        file = {}
        file.text = "Draw 1 card"
        file.tooltipTitle = "Draw 1 card"
        file.tooltipText = "Will only draw 1 card, instead of the usual 3"
        file.checked = OneCard
        function file.func()
            OneCard = not OneCard
            print("This change will take effect on your next game")

        end
        UIDropDownMenu_AddButton(file)
    
        --APPEARANCE MENU
        file = {}
        file.text = "Switch deck image"
        function file.func()
            local name
            local frame
            local bg 
            --print("This is currently unimplemented, but may be implemented in a future version")
            cardBack = not cardBack
            if cardBack then
                backofcard = "Interface\\AddOns\\CCLibrary\\Images\\allianceback"
            else
                backofcard = "Interface\\AddOns\\CCLibrary\\Images\\hordeback"
            end
            
            for i = 1, 52 do
                name = string.format("CardFrame%d", i)
                frame = CCPatienceCardFrames[name]
                if frame:GetAttribute("faceup") == false then
                    bg = frame:GetBackdrop()
                    bg.bgFile = backofcard
                    frame:SetBackdrop(bg)
                    frame:SetBackdropBorderColor(0, 0, 0)
                end
            end
            bg = PatienceFrameDeckSlot:GetBackdrop()
            bg.bgFile = backofcard
            PatienceFrameDeckSlot:SetBackdrop(bg)
            PatienceFrameDeckSlot:SetBackdropBorderColor(0, 0, 0)
        end
        UIDropDownMenu_AddButton(file)
    
        --EXIT BUTTON
        file = {}
        file.text = "Exit"
        function file.func()
            CCPatience:OnHide()
        end
        UIDropDownMenu_AddButton(file)

end

function CCPatience_FileDropDownOnLoad(self)
    UIDropDownMenu_Initialize(self, CCPatience_InitializeFileDropDown);
end

function CCPatience_FileButtonOnClick(self, button, down)
    ToggleDropDownMenu(1, nil, FileDropDown, self:GetName(), 0, 0)
end

function CCPatience_InitializeHelpDropDown(level)
    --create a table to use for local information
        local help = {}
    
        --create a title button
        help.text = "Help"
        help.isTitle = 1
        UIDropDownMenu_AddButton(help)
    
        --Display the rules in a new frame
        help = {}
        help.text = "Rules"
        function help.func()
            height = 400
            width = 400
            title = "Rules"
            msg = "1) Cards in play can only be placed on top of each other in reverse numerical order (K->A), and of opposite colour.\n\n2)Once cards have been stacked, they too may also be moved, providing the stack is legally allowed to be placed on the target card.\n\n3) If a slot is empty, only a King may be placed there.\n\n4) All extra cards are in the Deck (top left) clicking on this will display 1 or 3 more cards, depending on which option is chosen\n\n5) Cards may be placed in the slots at the top providing they are in numerical order (A->K) and of the same suit.\n\n6) Cards placed in the slots at the top are not locked and may be brought back down into play.\n\n7) WINNING CONDITION:- All cards are placed in the slots at the top.\n\n8) LOSING CONDITION:- There are no more moves that will progress the game"
            CCPatience:DisplayFrame(height, width, msg, title, 0)
            --open up rules frame
        end
        UIDropDownMenu_AddButton(help)
    
        --About section
        help = {}
        help.text = "About"
        function help.func()
            height = 220
            width = 350
            title = "About"
            msg = "Card Compilation: Patience Solitaire\nVersion: 1.2(beta)\nAuthor: Graeme Churchman\n\nCard Font: 'AshCan BB' from www.blambot.com\nImages on cards: From Blizzard Forums\n\nPlease Note this is a beta version. Please leave any comments on wowinterface.com or curse.com as to any bugs or improvements that could be made.  Thank you very much."
            CCPatience:DisplayFrame(height, width, msg, title, 0)
        end
        UIDropDownMenu_AddButton(help)
end

function CCPatience_HelpDropDownOnLoad(self)
    UIDropDownMenu_Initialize(self, CCPatience_InitializeHelpDropDown);
end

function CCPatience_HelpButtonOnClick(self, button, down)
    ToggleDropDownMenu(1, nil, HelpDropDown, self:GetName(), 0, 0)
end

---------------------------------------------------------------------
--function for displaying messages
---------------------------------------------------------------------
function CCPatience:DisplayFrame(height, width, msg, title, num)
    PatienceFrameAbout:SetHeight(height)
    PatienceFrameAbout:SetWidth(width)
    PatienceFrameAboutMsg:SetText(msg)
    PatienceFrameAboutTitle:SetText(title)
    PatienceFrameAbout:Show()

    if num == 0 then
        PatienceFrameAboutOK:Show()
        PatienceFrameAboutNG:Hide()
    else 
        PatienceFrameAboutNG:Show()
        PatienceFrameAboutOK:Hide()
    end
end

-------------------------------------------------------------------------------
--Slash Commands
-------------------------------------------------------------------------------

SLASH_CC1 = "/cc"
SlashCmdList["CC"] = function()
    print("/cc -functionality")
    print("/ccshow -open the game")
    print("/cchide -close the game")
end

SLASH_CCHIDE1 = "/cchide"
SLASH_CCHIDE2 = "/ccclose"
SLASH_CCHIDE3 = "/ccquit"
SlashCmdList["CCHIDE"] = function()
    CCPatience:OnHide()
end

SLASH_CCSHOW1 = "/ccshow"
SLASH_CCSHOW2 = "/ccopen"
SlashCmdList["CCSHOW"] = function()
    PatienceFrame:Show()
    showFlag = 1
end
